Compute - Create Or Update
Creates or updates compute. This call will overwrite a compute if it exists. This is a nonrecoverable operation. If your intent is to create a new compute, do a GET first to verify that it does not exist yet.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.MachineLearningServices/workspaces/{workspaceName}/computes/{computeName}?api-version=2025-09-01
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
compute
|
path | True |
string |
Name of the Azure Machine Learning compute. |
|
resource
|
path | True |
string minLength: 1maxLength: 90 |
The name of the resource group. The name is case insensitive. |
|
subscription
|
path | True |
string minLength: 1 |
The ID of the target subscription. |
|
workspace
|
path | True |
string pattern: ^[a-zA-Z0-9][a-zA-Z0-9_-]{2,32}$ |
Name of Azure Machine Learning workspace. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Request Body
| Name | Type | Description |
|---|---|---|
| identity |
The identity of the resource. |
|
| location |
string |
Specifies the location of the resource. |
| properties | Compute: |
Compute properties |
| sku |
The sku of the workspace. |
|
| tags |
object |
Contains resource tags defined as key/value pairs. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Compute creation or update initiated. |
|
| 201 Created |
Compute creation or update initiated. Headers Azure-AsyncOperation: string |
|
| Other Status Codes |
Error response describing why the request failed. |
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| user_impersonation | impersonate your user account |
Examples
Attach a Kubernetes Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"description": "some compute",
"resourceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/testrg123/providers/Microsoft.ContainerService/managedClusters/compute123-56826-c9b00420020b2",
"computeType": "Kubernetes",
"properties": {
"namespace": "default",
"defaultInstanceType": "defaultInstanceType",
"instanceTypes": {
"defaultInstanceType": {
"nodeSelector": null,
"resources": {
"requests": {
"cpu": "1",
"memory": "4Gi",
"nvidia.com/gpu": null
},
"limits": {
"cpu": "1",
"memory": "4Gi",
"nvidia.com/gpu": null
}
}
}
}
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"description": "some compute",
"resourceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/testrg123/providers/Microsoft.ContainerService/managedClusters/compute123-56826-c9b00420020b2",
"computeType": "Kubernetes",
"provisioningState": "Creating",
"properties": {
"relayConnectionString": null,
"serviceBusConnectionString": null,
"extensionPrincipalId": null,
"extensionInstanceReleaseTrain": "stable",
"vcName": null,
"namespace": "default",
"defaultInstanceType": "defaultInstanceType",
"instanceTypes": {
"defaultInstanceType": {
"nodeSelector": null,
"resources": {
"requests": {
"cpu": "1",
"memory": "4Gi",
"nvidia.com/gpu": null
},
"limits": {
"cpu": "1",
"memory": "4Gi",
"nvidia.com/gpu": null
}
}
}
}
}
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"description": "some compute",
"resourceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/testrg123/providers/Microsoft.ContainerService/managedClusters/compute123-56826-c9b00420020b2",
"computeType": "Kubernetes",
"provisioningState": "Creating",
"properties": {
"relayConnectionString": null,
"serviceBusConnectionString": null,
"extensionPrincipalId": null,
"extensionInstanceReleaseTrain": "stable",
"vcName": null,
"namespace": "default",
"defaultInstanceType": "defaultInstanceType",
"instanceTypes": {
"defaultInstanceType": {
"nodeSelector": null,
"resources": {
"requests": {
"cpu": "1",
"memory": "4Gi",
"nvidia.com/gpu": null
},
"limits": {
"cpu": "1",
"memory": "4Gi",
"nvidia.com/gpu": null
}
}
}
}
}
}
}
Create a AML Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "AmlCompute",
"properties": {
"vmSize": "STANDARD_NC6",
"vmPriority": "Dedicated",
"osType": "Windows",
"virtualMachineImage": {
"id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.Compute/galleries/myImageGallery/images/myImageDefinition/versions/0.0.1"
},
"isolatedNetwork": false,
"scaleSettings": {
"maxNodeCount": 1,
"minNodeCount": 0,
"nodeIdleTimeBeforeScaleDown": "PT5M"
},
"remoteLoginPortPublicAccess": "NotSpecified",
"enableNodePublicIp": true
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "AmlCompute",
"provisioningState": "Creating"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "AmlCompute",
"provisioningState": "Creating"
}
}
Create a DataFactory Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "DataFactory"
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "DataFactory",
"provisioningState": "Creating"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "DataFactory",
"provisioningState": "Creating"
}
}
Create an AKS Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "AKS"
}
}
Sample response
{
"id": "subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "AKS",
"provisioningState": "Creating"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "AKS",
"provisioningState": "Creating"
}
}
Create an ComputeInstance Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"properties": {
"vmSize": "STANDARD_NC6",
"subnet": {
"id": "test-subnet-resource-id"
},
"applicationSharingPolicy": "Personal",
"customServices": [
{
"docker": {
"privileged": true
},
"environmentVariables": {
"test_variable": {
"type": "local",
"value": "test_value"
}
},
"volumes": [
{
"type": "bind",
"readOnly": false,
"source": "/home/azureuser/cloudfiles",
"target": "/home/azureuser/cloudfiles"
}
],
"endpoints": [
{
"name": "connect",
"target": 8787,
"published": 8787,
"protocol": "http"
}
],
"image": {
"type": "docker",
"reference": "ghcr.io/azure/rocker-rstudio-ml-verse:latest"
},
"name": "rstudio"
}
],
"sshSettings": {
"sshPublicAccess": "Disabled"
},
"computeInstanceAuthorizationType": "personal",
"personalComputeInstanceSettings": {
"assignedUser": {
"objectId": "00000000-0000-0000-0000-000000000000",
"tenantId": "00000000-0000-0000-0000-000000000000"
}
}
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"provisioningState": "Creating"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"provisioningState": "Creating"
}
}
Create an ComputeInstance Compute with minimal inputs
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"properties": {
"vmSize": "STANDARD_NC6"
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"provisioningState": "Creating"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"provisioningState": "Creating"
}
}
Create an ComputeInstance Compute with Schedules
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"properties": {
"vmSize": "STANDARD_NC6",
"applicationSharingPolicy": "Personal",
"sshSettings": {
"sshPublicAccess": "Disabled"
},
"computeInstanceAuthorizationType": "personal",
"personalComputeInstanceSettings": {
"assignedUser": {
"objectId": "00000000-0000-0000-0000-000000000000",
"tenantId": "00000000-0000-0000-0000-000000000000"
}
},
"schedules": {
"computeStartStop": [
{
"status": "Enabled",
"action": "Stop",
"triggerType": "Cron",
"cron": {
"expression": "0 18 * * *",
"startTime": "2021-04-23T01:30:00",
"timeZone": "Pacific Standard Time"
}
}
]
}
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"provisioningState": "Creating"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"computeType": "ComputeInstance",
"provisioningState": "Creating"
}
}
Update a AML Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"computeType": "AmlCompute",
"description": "some compute",
"properties": {
"scaleSettings": {
"maxNodeCount": 4,
"minNodeCount": 4,
"nodeIdleTimeBeforeScaleDown": "PT5M"
}
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus2",
"properties": {
"description": "some compute",
"createdOn": "2021-04-01T22:00:00.0000000+00:00",
"modifiedOn": "2021-04-01T22:00:00.0000000+00:00",
"computeType": "AmlCompute",
"provisioningState": "Succeeded",
"properties": {
"vmSize": "STANDARD_NC6",
"vmPriority": "Dedicated",
"osType": "Windows",
"virtualMachineImage": null,
"isolatedNetwork": false,
"subnet": {
"id": "test-subnet-resource-id"
},
"scaleSettings": {
"maxNodeCount": 1,
"minNodeCount": 0,
"nodeIdleTimeBeforeScaleDown": "PT5M"
},
"remoteLoginPortPublicAccess": "Enabled",
"allocationState": "Resizing",
"allocationStateTransitionTime": "2017-09-27T22:28:08.998Z",
"errors": null,
"currentNodeCount": 0,
"targetNodeCount": 1,
"nodeStateCounts": {
"preparingNodeCount": 0,
"runningNodeCount": 0,
"idleNodeCount": 0,
"unusableNodeCount": 0,
"leavingNodeCount": 0,
"preemptedNodeCount": 0
},
"enableNodePublicIp": true
}
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus2",
"properties": {
"description": "some compute",
"computeType": "AmlCompute",
"provisioningState": "Updating"
}
}
Update an AKS Compute
Sample request
PUT https://management.azure.com/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123?api-version=2025-09-01
{
"location": "eastus",
"properties": {
"description": "some compute",
"resourceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/testrg123/providers/Microsoft.ContainerService/managedClusters/compute123-56826-c9b00420020b2",
"computeType": "AKS",
"properties": {
"agentCount": 4
}
}
}
Sample response
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"description": "some compute",
"resourceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/testrg123/providers/Microsoft.ContainerService/managedClusters/compute123-56826-c9b00420020b2",
"computeType": "AKS",
"provisioningState": "Succeeded",
"properties": {
"agentCount": 4
}
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/...pathToOperationStatus...
{
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/testrg123/providers/Microsoft.MachineLearningServices/workspaces/workspaces123/computes/compute123",
"type": "Microsoft.MachineLearningServices/workspaces/computes",
"name": "compute123",
"location": "eastus",
"properties": {
"description": "some compute",
"resourceId": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourcegroups/testrg123/providers/Microsoft.ContainerService/managedClusters/compute123-56826-c9b00420020b2",
"computeType": "AKS",
"provisioningState": "Updating"
}
}
Definitions
| Name | Description |
|---|---|
| AKS |
A Machine Learning compute based on AKS. |
|
Aks |
Advance configuration for AKS networking |
|
Allocation |
Allocation state. |
|
Aml |
An Azure Machine Learning compute. |
|
Aml |
AML Compute properties |
|
application |
Sharing policy for applications on this compute instance |
|
Assigned |
A user that can be assigned to a compute instance. |
| autosave |
Auto save settings. |
|
Bind |
Describes the bind options for the container |
| caching |
Caching type of Data Disk. |
|
Cluster |
Intended usage of the cluster |
|
Compute |
An Azure Machine Learning compute instance. |
|
Compute |
Defines an Aml Instance application and its connectivity endpoint URI. |
|
Compute |
Compute Instance Authorization type. |
|
Compute |
Defines all connectivity endpoints and properties for an ComputeInstance. |
|
Compute |
Defines an Aml Instance container. |
|
Compute |
Describes information on user who created this ComputeInstance. |
|
Compute |
Defines an Aml Instance DataDisk. |
|
Compute |
Defines an Aml Instance DataMount. |
|
Compute |
Environment information |
|
Compute |
The last operation on ComputeInstance. |
|
Compute |
Compute Instance properties |
|
Compute |
Specifies policy and settings for SSH access. |
|
Compute |
Current state of an ComputeInstance. |
|
Compute |
Version of computeInstance. |
|
Compute |
The compute power action. |
|
Compute |
Enum to describe the frequency of a compute recurrence schedule |
|
Compute |
|
|
Compute |
Machine Learning compute object wrapped into ARM resource envelope. |
|
Compute |
The list of schedules to be applied on the computes |
|
Compute |
Compute start stop schedule properties |
|
Compute |
Is the trigger type recurrence or cron. |
|
Compute |
The type of compute |
|
Compute |
Enum of weekday |
|
created |
The type of identity that created the resource. |
| Cron |
The workflow trigger cron for ComputeStartStop schedule type. |
|
Custom |
Specifies the custom service configuration |
| Databricks |
A DataFactory compute. |
|
Databricks |
Properties of Databricks |
|
Data |
A DataFactory compute. |
|
Data |
A DataLakeAnalytics compute. |
| Docker |
Docker container configuration |
| Endpoint |
Describes the endpoint configuration for the container |
|
Environment |
Environment Variables for the container |
|
Environment |
Type of Environment Variable |
|
Error |
The resource management error additional info. |
|
Error |
The error detail. |
|
Error |
Error response |
| HDInsight |
A HDInsight compute. |
|
HDInsight |
HDInsight compute properties |
| Image |
Describes the Image Specifications |
|
Image |
Returns metadata about the operating system image for this compute instance. |
|
Image |
Type of the image |
|
Instance |
Instance type schema. |
| Kubernetes |
A Machine Learning compute based on Kubernetes Compute. |
|
Kubernetes |
Kubernetes properties |
|
Load |
Load Balancer Type |
|
Managed |
Managed service identity (system assigned and/or user assigned identities) |
|
Managed |
Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed). |
|
mount |
Mount Action. |
|
mount |
Mount state. |
| network |
network of this container. |
|
Node |
Counts of various compute node states on the amlCompute. |
|
Operation |
Name of the last operation. |
|
Operation |
Operation status. |
|
operation |
Trigger of operation. |
|
Os |
Compute OS Type |
|
Personal |
Settings for a personal compute instance. |
| Properties |
AKS properties |
| protocol |
Endpoint Communication Protocol |
|
Provisioning |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
provisioning |
The current deployment state of schedule. |
| Recurrence |
The workflow trigger recurrence for ComputeStartStop schedule type. |
|
remote |
Close remote Login Access Port |
|
Resource |
Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet. |
| Resources |
Resource requests/limits for this instance type |
|
Scale |
scale settings for AML Compute |
|
Schedule |
|
|
Schedule |
The current deployment state of schedule. |
|
Schedule |
Is the schedule enabled or disabled? |
|
Script |
Script reference |
|
Scripts |
Customized setup scripts |
|
Setup |
Details of customized scripts to execute for setting up the cluster. |
| Sku |
The resource model definition representing SKU |
|
Sku |
This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT. |
|
source |
Data source type. |
|
ssh |
Access policy for SSH |
|
Ssl |
Enable or disable ssl for scoring |
|
Ssl |
The ssl configuration for scoring |
|
storage |
type of this storage account. |
|
Synapse |
A SynapseSpark compute. |
|
system |
Metadata pertaining to creation and last modification of the resource. |
|
System |
A system service running on a compute. |
|
Tmpfs |
Describes the tmpfs options for the container |
|
User |
Settings for user account that gets created on each on the nodes of a compute. |
|
User |
User assigned identity properties |
|
Virtual |
A Machine Learning compute based on Azure Virtual Machines. |
|
Virtual |
Virtual Machine image for Windows AML Compute |
|
Virtual |
Admin credentials for virtual machine |
|
Vm |
Virtual Machine priority |
|
Volume |
Describes the volume configuration for the container |
|
Volume |
Type of Volume Definition |
|
Volume |
Describes the volume options for the container |
AKS
A Machine Learning compute based on AKS.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties |
AKS properties |
|
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
AksNetworkingConfiguration
Advance configuration for AKS networking
| Name | Type | Description |
|---|---|---|
| dnsServiceIP |
string pattern: ^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$ |
An IP address assigned to the Kubernetes DNS service. It must be within the Kubernetes service address range specified in serviceCidr. |
| dockerBridgeCidr |
string pattern: ^([0-9]{1,3}\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$ |
A CIDR notation IP range assigned to the Docker bridge network. It must not overlap with any Subnet IP ranges or the Kubernetes service address range. |
| serviceCidr |
string pattern: ^([0-9]{1,3}\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$ |
A CIDR notation IP range from which to assign service cluster IPs. It must not overlap with any Subnet IP ranges. |
| subnetId |
string |
Virtual network subnet resource ID the compute nodes belong to |
AllocationState
Allocation state.
| Value | Description |
|---|---|
| Steady | |
| Resizing |
AmlCompute
An Azure Machine Learning compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties |
Properties of AmlCompute |
|
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
AmlComputeProperties
AML Compute properties
| Name | Type | Default value | Description |
|---|---|---|---|
| allocationState |
Allocation state. |
||
| allocationStateTransitionTime |
string (date-time) |
Allocation state transition time. |
|
| currentNodeCount |
integer (int32) |
Current node count. |
|
| enableNodePublicIp |
boolean |
True |
Enable node public IP. |
| errors |
Errors. |
||
| isolatedNetwork |
boolean |
Network is isolated or not |
|
| nodeStateCounts |
Node state counts. |
||
| osType | Linux |
Compute OS Type |
|
| propertyBag |
object |
A property bag containing additional properties. |
|
| remoteLoginPortPublicAccess | NotSpecified |
Close remote Login Access Port |
|
| scaleSettings |
Scale settings for AML Compute |
||
| subnet |
Subnet. |
||
| targetNodeCount |
integer (int32) |
Target node count. |
|
| userAccountCredentials |
User account credentials. |
||
| virtualMachineImage |
Virtual Machine image for AML Compute - windows only |
||
| vmPriority |
Virtual Machine priority |
||
| vmSize |
string |
Virtual Machine Size |
applicationSharingPolicy
Sharing policy for applications on this compute instance
| Value | Description |
|---|---|
| Personal | |
| Shared |
AssignedUser
A user that can be assigned to a compute instance.
| Name | Type | Description |
|---|---|---|
| objectId |
string |
User’s AAD Object Id. |
| tenantId |
string |
User’s AAD Tenant Id. |
autosave
Auto save settings.
| Value | Description |
|---|---|
| None | |
| Local | |
| Remote |
BindOptions
Describes the bind options for the container
| Name | Type | Description |
|---|---|---|
| createHostPath |
boolean |
Indicate whether to create host path. |
| propagation |
string |
Type of Bind Option |
| selinux |
string |
Mention the selinux options. |
caching
Caching type of Data Disk.
| Value | Description |
|---|---|
| None | |
| ReadOnly | |
| ReadWrite |
ClusterPurpose
Intended usage of the cluster
| Value | Description |
|---|---|
| FastProd | |
| DenseProd | |
| DevTest |
ComputeInstance
An Azure Machine Learning compute instance.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties |
Properties of ComputeInstance |
|
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
ComputeInstanceApplication
Defines an Aml Instance application and its connectivity endpoint URI.
| Name | Type | Description |
|---|---|---|
| displayName |
string |
Name of the ComputeInstance application. |
| endpointUri |
string |
Application' endpoint URI. |
ComputeInstanceAuthorizationType
Compute Instance Authorization type.
| Value | Description |
|---|---|
| personal |
ComputeInstanceConnectivityEndpoints
Defines all connectivity endpoints and properties for an ComputeInstance.
| Name | Type | Description |
|---|---|---|
| privateIpAddress |
string |
Private IP Address of this ComputeInstance (local to the VNET in which the compute instance is deployed). |
| publicIpAddress |
string |
Public IP Address of this ComputeInstance. |
ComputeInstanceContainer
Defines an Aml Instance container.
| Name | Type | Description |
|---|---|---|
| autosave |
Auto save settings. |
|
| environment |
Environment information of this container. |
|
| gpu |
string |
Information of GPU. |
| name |
string |
Name of the ComputeInstance container. |
| network |
network of this container. |
|
| services |
object[] |
services of this containers. |
ComputeInstanceCreatedBy
Describes information on user who created this ComputeInstance.
| Name | Type | Description |
|---|---|---|
| userId |
string |
Uniquely identifies the user within his/her organization. |
| userName |
string |
Name of the user. |
| userOrgId |
string |
Uniquely identifies user' Azure Active Directory organization. |
ComputeInstanceDataDisk
Defines an Aml Instance DataDisk.
| Name | Type | Default value | Description |
|---|---|---|---|
| caching |
Caching type of Data Disk. |
||
| diskSizeGB |
integer (int32) |
The initial disk size in gigabytes. |
|
| lun |
integer (int32) |
The logical unit number. |
|
| storageAccountType | Standard_LRS |
type of this storage account. |
ComputeInstanceDataMount
Defines an Aml Instance DataMount.
| Name | Type | Description |
|---|---|---|
| createdBy |
string |
who this data mount created by. |
| error |
string |
Error of this data mount. |
| mountAction |
Mount Action. |
|
| mountName |
string |
name of the ComputeInstance data mount. |
| mountPath |
string |
Path of this data mount. |
| mountState |
Mount state. |
|
| mountedOn |
string (date-time) |
Mounted time. |
| source |
string |
Source of the ComputeInstance data mount. |
| sourceType |
Data source type. |
ComputeInstanceEnvironmentInfo
Environment information
| Name | Type | Description |
|---|---|---|
| name |
string |
name of environment. |
| version |
string |
version of environment. |
ComputeInstanceLastOperation
The last operation on ComputeInstance.
| Name | Type | Description |
|---|---|---|
| operationName |
Name of the last operation. |
|
| operationStatus |
Operation status. |
|
| operationTime |
string (date-time) |
Time of the last operation. |
| operationTrigger |
Trigger of operation. |
ComputeInstanceProperties
Compute Instance properties
| Name | Type | Default value | Description |
|---|---|---|---|
| applicationSharingPolicy | Shared |
Sharing policy for applications on this compute instance |
|
| applications |
Describes available applications and their endpoints on this ComputeInstance. |
||
| computeInstanceAuthorizationType | personal |
Compute Instance Authorization type. |
|
| connectivityEndpoints |
Describes all connectivity endpoints available for this ComputeInstance. |
||
| containers |
Describes informations of containers on this ComputeInstance. |
||
| createdBy |
Describes information on user who created this ComputeInstance. |
||
| customServices |
List of Custom Services added to the compute. |
||
| dataDisks |
Describes informations of dataDisks on this ComputeInstance. |
||
| dataMounts |
Describes informations of dataMounts on this ComputeInstance. |
||
| enableNodePublicIp |
boolean |
Enable node public IP. |
|
| errors |
Errors. |
||
| lastOperation |
The last operation on ComputeInstance. |
||
| osImageMetadata |
Returns metadata about the operating system image for this compute instance. |
||
| personalComputeInstanceSettings |
Personal Compute Instance settings. |
||
| schedules |
The list of schedules to be applied on the computes. |
||
| setupScripts |
Details of customized scripts to execute for setting up the cluster. |
||
| sshSettings |
Specifies policy and settings for SSH access. |
||
| state |
The current state of this ComputeInstance. |
||
| subnet |
Subnet. |
||
| versions |
ComputeInstance version. |
||
| vmSize |
string |
Virtual Machine Size |
ComputeInstanceSshSettings
Specifies policy and settings for SSH access.
| Name | Type | Default value | Description |
|---|---|---|---|
| adminPublicKey |
string |
Specifies the SSH rsa public key file as a string. Use "ssh-keygen -t rsa -b 2048" to generate your SSH key pairs. |
|
| adminUserName |
string |
Describes the admin user name. |
|
| sshPort |
integer (int32) |
Describes the port for connecting through SSH. |
|
| sshPublicAccess | Disabled |
Access policy for SSH |
ComputeInstanceState
Current state of an ComputeInstance.
| Value | Description |
|---|---|
| Creating | |
| CreateFailed | |
| Deleting | |
| Running | |
| Restarting | |
| JobRunning | |
| SettingUp | |
| SetupFailed | |
| Starting | |
| Stopped | |
| Stopping | |
| UserSettingUp | |
| UserSetupFailed | |
| Unknown | |
| Unusable |
ComputeInstanceVersion
Version of computeInstance.
| Name | Type | Description |
|---|---|---|
| runtime |
string |
Runtime of compute instance. |
ComputePowerAction
The compute power action.
| Value | Description |
|---|---|
| Start | |
| Stop |
ComputeRecurrenceFrequency
Enum to describe the frequency of a compute recurrence schedule
| Value | Description |
|---|---|
| Minute |
Minute frequency |
| Hour |
Hour frequency |
| Day |
Day frequency |
| Week |
Week frequency |
| Month |
Month frequency |
ComputeRecurrenceSchedule
| Name | Type | Description |
|---|---|---|
| hours |
integer[] (int32) |
[Required] List of hours for the schedule. |
| minutes |
integer[] (int32) |
[Required] List of minutes for the schedule. |
| monthDays |
integer[] (int32) |
List of month days for the schedule |
| weekDays |
List of days for the schedule. |
ComputeResource
Machine Learning compute object wrapped into ARM resource envelope.
| Name | Type | Description |
|---|---|---|
| id |
string |
Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName} |
| identity |
The identity of the resource. |
|
| location |
string |
Specifies the location of the resource. |
| name |
string |
The name of the resource |
| properties | Compute: |
Compute properties |
| sku |
The sku of the workspace. |
|
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
|
| tags |
object |
Contains resource tags defined as key/value pairs. |
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
ComputeSchedules
The list of schedules to be applied on the computes
| Name | Type | Description |
|---|---|---|
| computeStartStop |
The list of compute start stop schedules to be applied. |
ComputeStartStopSchedule
Compute start stop schedule properties
| Name | Type | Description |
|---|---|---|
| action |
[Required] The compute power action. |
|
| cron |
Required if triggerType is Cron. |
|
| id |
string |
A system assigned id for the schedule. |
| provisioningStatus |
The current deployment state of schedule. |
|
| recurrence |
Required if triggerType is Recurrence. |
|
| schedule |
[Deprecated] Not used any more. |
|
| status |
Is the schedule enabled or disabled? |
|
| triggerType |
[Required] The schedule trigger type. |
ComputeTriggerType
Is the trigger type recurrence or cron.
| Value | Description |
|---|---|
| Recurrence | |
| Cron |
ComputeType
The type of compute
| Value | Description |
|---|---|
| AKS | |
| Kubernetes | |
| AmlCompute | |
| ComputeInstance | |
| DataFactory | |
| VirtualMachine | |
| HDInsight | |
| Databricks | |
| DataLakeAnalytics | |
| SynapseSpark |
ComputeWeekDay
Enum of weekday
| Value | Description |
|---|---|
| Monday |
Monday weekday |
| Tuesday |
Tuesday weekday |
| Wednesday |
Wednesday weekday |
| Thursday |
Thursday weekday |
| Friday |
Friday weekday |
| Saturday |
Saturday weekday |
| Sunday |
Sunday weekday |
createdByType
The type of identity that created the resource.
| Value | Description |
|---|---|
| User | |
| Application | |
| ManagedIdentity | |
| Key |
Cron
The workflow trigger cron for ComputeStartStop schedule type.
| Name | Type | Default value | Description |
|---|---|---|---|
| expression |
string |
[Required] Specifies cron expression of schedule. The expression should follow NCronTab format. |
|
| startTime |
string |
The start time in yyyy-MM-ddTHH:mm:ss format. |
|
| timeZone |
string |
UTC |
Specifies time zone in which the schedule runs. TimeZone should follow Windows time zone format. Refer: https://docs.microsoft.com/en-us/windows-hardware/manufacture/desktop/default-time-zones?view=windows-11 |
CustomService
Specifies the custom service configuration
| Name | Type | Description |
|---|---|---|
| docker |
Describes the docker settings for the image |
|
| endpoints |
Endpoint[] |
Configuring the endpoints for the container |
| environmentVariables |
<string,
Environment |
Environment Variable for the container |
| image |
Describes the Image Specifications |
|
| name |
string |
Name of the Custom Service |
| volumes |
Configuring the volumes for the container |
Databricks
A DataFactory compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties |
Properties of Databricks |
|
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
DatabricksProperties
Properties of Databricks
| Name | Type | Description |
|---|---|---|
| databricksAccessToken |
string |
Databricks access token |
| workspaceUrl |
string |
Workspace Url |
DataFactory
A DataFactory compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
DataLakeAnalytics
A DataLakeAnalytics compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties | ||
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
Docker
Docker container configuration
| Name | Type | Description |
|---|---|---|
| privileged |
boolean |
Indicate whether container shall run in privileged or non-privileged mode. |
Endpoint
Describes the endpoint configuration for the container
| Name | Type | Default value | Description |
|---|---|---|---|
| hostIp |
string |
Host IP over which the application is exposed from the container |
|
| name |
string |
Name of the Endpoint |
|
| protocol | tcp |
Endpoint Communication Protocol |
|
| published |
integer (int32) |
Port over which the application is exposed from container. |
|
| target |
integer (int32) |
Application port inside the container. |
EnvironmentVariable
Environment Variables for the container
| Name | Type | Default value | Description |
|---|---|---|---|
| type | local |
Type of Environment Variable |
|
| value |
string |
Value of the Environment variable |
EnvironmentVariableType
Type of Environment Variable
| Value | Description |
|---|---|
| local |
ErrorAdditionalInfo
The resource management error additional info.
| Name | Type | Description |
|---|---|---|
| info |
object |
The additional info. |
| type |
string |
The additional info type. |
ErrorDetail
The error detail.
| Name | Type | Description |
|---|---|---|
| additionalInfo |
The error additional info. |
|
| code |
string |
The error code. |
| details |
The error details. |
|
| message |
string |
The error message. |
| target |
string |
The error target. |
ErrorResponse
Error response
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
HDInsight
A HDInsight compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties |
HDInsight compute properties |
|
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
HDInsightProperties
HDInsight compute properties
| Name | Type | Description |
|---|---|---|
| address |
string |
Public IP address of the master node of the cluster. |
| administratorAccount |
Admin credentials for master node of the cluster |
|
| sshPort |
integer (int32) |
Port open for ssh connections on the master node of the cluster. |
Image
Describes the Image Specifications
| Name | Type | Default value | Description |
|---|---|---|---|
| reference |
string |
Image reference |
|
| type | docker |
Type of the image |
ImageMetadata
Returns metadata about the operating system image for this compute instance.
| Name | Type | Description |
|---|---|---|
| currentImageVersion |
string |
Specifies the current operating system image version this compute instance is running on. |
| isLatestOsImageVersion |
boolean |
Specifies whether this compute instance is running on the latest operating system image. |
| latestImageVersion |
string |
Specifies the latest available operating system image version. |
ImageType
Type of the image
| Value | Description |
|---|---|
| docker | |
| azureml |
InstanceTypeSchema
Instance type schema.
| Name | Type | Description |
|---|---|---|
| nodeSelector |
object |
Node Selector |
| resources |
Resource requests/limits for this instance type |
Kubernetes
A Machine Learning compute based on Kubernetes Compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties |
Properties of Kubernetes |
|
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
KubernetesProperties
Kubernetes properties
| Name | Type | Default value | Description |
|---|---|---|---|
| defaultInstanceType |
string |
Default instance type |
|
| extensionInstanceReleaseTrain |
string |
Extension instance release train. |
|
| extensionPrincipalId |
string |
Extension principal-id. |
|
| instanceTypes |
<string,
Instance |
Instance Type Schema |
|
| namespace |
string |
default |
Compute namespace |
| relayConnectionString |
string |
Relay connection string. |
|
| serviceBusConnectionString |
string |
ServiceBus connection string. |
|
| vcName |
string |
VC name. |
LoadBalancerType
Load Balancer Type
| Value | Description |
|---|---|
| PublicIp | |
| InternalLoadBalancer |
ManagedServiceIdentity
Managed service identity (system assigned and/or user assigned identities)
| Name | Type | Description |
|---|---|---|
| principalId |
string (uuid) |
The service principal ID of the system assigned identity. This property will only be provided for a system assigned identity. |
| tenantId |
string (uuid) |
The tenant ID of the system assigned identity. This property will only be provided for a system assigned identity. |
| type |
Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed). |
|
| userAssignedIdentities |
<string,
User |
User-Assigned Identities |
ManagedServiceIdentityType
Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
| Value | Description |
|---|---|
| None | |
| SystemAssigned | |
| UserAssigned | |
| SystemAssigned,UserAssigned |
mountAction
Mount Action.
| Value | Description |
|---|---|
| Mount | |
| Unmount |
mountState
Mount state.
| Value | Description |
|---|---|
| MountRequested | |
| Mounted | |
| MountFailed | |
| UnmountRequested | |
| UnmountFailed | |
| Unmounted |
network
network of this container.
| Value | Description |
|---|---|
| Bridge | |
| Host |
NodeStateCounts
Counts of various compute node states on the amlCompute.
| Name | Type | Description |
|---|---|---|
| idleNodeCount |
integer (int32) |
Idle node count. |
| leavingNodeCount |
integer (int32) |
Leaving node count. |
| preemptedNodeCount |
integer (int32) |
Preempted node count. |
| preparingNodeCount |
integer (int32) |
Preparing node count. |
| runningNodeCount |
integer (int32) |
Running node count. |
| unusableNodeCount |
integer (int32) |
Unusable node count. |
OperationName
Name of the last operation.
| Value | Description |
|---|---|
| Create | |
| Start | |
| Stop | |
| Restart | |
| Reimage | |
| Delete |
OperationStatus
Operation status.
| Value | Description |
|---|---|
| InProgress | |
| Succeeded | |
| CreateFailed | |
| StartFailed | |
| StopFailed | |
| RestartFailed | |
| ReimageFailed | |
| DeleteFailed |
operationTrigger
Trigger of operation.
| Value | Description |
|---|---|
| User | |
| Schedule | |
| IdleShutdown |
OsType
Compute OS Type
| Value | Description |
|---|---|
| Linux | |
| Windows |
PersonalComputeInstanceSettings
Settings for a personal compute instance.
| Name | Type | Description |
|---|---|---|
| assignedUser |
Assigned User. |
Properties
AKS properties
| Name | Type | Default value | Description |
|---|---|---|---|
| agentCount |
integer (int32) minimum: 0 |
Number of agents |
|
| agentVmSize |
string |
Agent virtual machine size |
|
| aksNetworkingConfiguration |
AKS networking configuration for vnet |
||
| clusterFqdn |
string |
Cluster full qualified domain name |
|
| clusterPurpose | FastProd |
Intended usage of the cluster |
|
| loadBalancerSubnet |
string |
Load Balancer Subnet |
|
| loadBalancerType | PublicIp |
Load Balancer Type |
|
| sslConfiguration |
SSL configuration |
||
| systemServices |
System services |
protocol
Endpoint Communication Protocol
| Value | Description |
|---|---|
| tcp | |
| udp | |
| http |
ProvisioningState
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed.
| Value | Description |
|---|---|
| Unknown | |
| Updating | |
| Creating | |
| Deleting | |
| Succeeded | |
| Failed | |
| Canceled |
provisioningStatus
The current deployment state of schedule.
| Value | Description |
|---|---|
| Completed | |
| Provisioning | |
| Failed |
Recurrence
The workflow trigger recurrence for ComputeStartStop schedule type.
| Name | Type | Default value | Description |
|---|---|---|---|
| frequency |
[Required] The frequency to trigger schedule. |
||
| interval |
integer (int32) |
[Required] Specifies schedule interval in conjunction with frequency |
|
| schedule |
[Required] The recurrence schedule. |
||
| startTime |
string |
The start time in yyyy-MM-ddTHH:mm:ss format. |
|
| timeZone |
string |
UTC |
Specifies time zone in which the schedule runs. TimeZone should follow Windows time zone format. Refer: https://docs.microsoft.com/en-us/windows-hardware/manufacture/desktop/default-time-zones?view=windows-11 |
remoteLoginPortPublicAccess
Close remote Login Access Port
| Value | Description |
|---|---|
| Enabled | |
| Disabled | |
| NotSpecified |
ResourceId
Represents a resource ID. For example, for a subnet, it is the resource URL for the subnet.
| Name | Type | Description |
|---|---|---|
| id |
string |
The ID of the resource |
Resources
Resource requests/limits for this instance type
| Name | Type | Description |
|---|---|---|
| limits |
object |
Resource limits for this instance type |
| requests |
object |
Resource requests for this instance type |
ScaleSettings
scale settings for AML Compute
| Name | Type | Default value | Description |
|---|---|---|---|
| maxNodeCount |
integer (int32) |
Max number of nodes to use |
|
| minNodeCount |
integer (int32) |
0 |
Min number of nodes to use |
| nodeIdleTimeBeforeScaleDown |
string (duration) |
Node Idle Time before scaling down amlCompute. This string needs to be in the RFC Format. |
ScheduleBase
| Name | Type | Description |
|---|---|---|
| id |
string |
A system assigned id for the schedule. |
| provisioningStatus |
The current deployment state of schedule. |
|
| status |
Is the schedule enabled or disabled? |
ScheduleProvisioningState
The current deployment state of schedule.
| Value | Description |
|---|---|
| Completed | |
| Provisioning | |
| Failed |
ScheduleStatus
Is the schedule enabled or disabled?
| Value | Description |
|---|---|
| Enabled | |
| Disabled |
ScriptReference
Script reference
| Name | Type | Description |
|---|---|---|
| scriptArguments |
string |
Optional command line arguments passed to the script to run. |
| scriptData |
string |
The location of scripts in the mounted volume. |
| scriptSource |
string |
The storage source of the script: workspace. |
| timeout |
string |
Optional time period passed to timeout command. |
ScriptsToExecute
Customized setup scripts
| Name | Type | Description |
|---|---|---|
| creationScript |
Script that's run only once during provision of the compute. |
|
| startupScript |
Script that's run every time the machine starts. |
SetupScripts
Details of customized scripts to execute for setting up the cluster.
| Name | Type | Description |
|---|---|---|
| scripts |
Customized setup scripts |
Sku
The resource model definition representing SKU
| Name | Type | Description |
|---|---|---|
| capacity |
integer (int32) |
If the SKU supports scale out/in then the capacity integer should be included. If scale out/in is not possible for the resource this may be omitted. |
| family |
string |
If the service has different generations of hardware, for the same SKU, then that can be captured here. |
| name |
string |
The name of the SKU. Ex - P3. It is typically a letter+number code |
| size |
string |
The SKU size. When the name field is the combination of tier and some other value, this would be the standalone code. |
| tier |
This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT. |
SkuTier
This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT.
| Value | Description |
|---|---|
| Free | |
| Basic | |
| Standard | |
| Premium |
sourceType
Data source type.
| Value | Description |
|---|---|
| Dataset | |
| Datastore | |
| URI |
sshPublicAccess
Access policy for SSH
| Value | Description |
|---|---|
| Enabled | |
| Disabled |
SslConfigStatus
Enable or disable ssl for scoring
| Value | Description |
|---|---|
| Disabled | |
| Enabled | |
| Auto |
SslConfiguration
The ssl configuration for scoring
| Name | Type | Description |
|---|---|---|
| cert |
string |
Cert data |
| cname |
string |
CNAME of the cert |
| key |
string |
Key data |
| leafDomainLabel |
string |
Leaf domain label of public endpoint |
| overwriteExistingDomain |
boolean |
Indicates whether to overwrite existing domain label. |
| status |
Enable or disable ssl for scoring |
storageAccountType
type of this storage account.
| Value | Description |
|---|---|
| Standard_LRS | |
| Premium_LRS |
SynapseSpark
A SynapseSpark compute.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties | ||
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
systemData
Metadata pertaining to creation and last modification of the resource.
| Name | Type | Description |
|---|---|---|
| createdAt |
string (date-time) |
The timestamp of resource creation (UTC). |
| createdBy |
string |
The identity that created the resource. |
| createdByType |
The type of identity that created the resource. |
|
| lastModifiedAt |
string (date-time) |
The timestamp of resource last modification (UTC) |
| lastModifiedBy |
string |
The identity that last modified the resource. |
| lastModifiedByType |
The type of identity that last modified the resource. |
SystemService
A system service running on a compute.
| Name | Type | Description |
|---|---|---|
| publicIpAddress |
string |
Public IP address |
| systemServiceType |
string |
The type of this system service. |
| version |
string |
The version for this type. |
TmpfsOptions
Describes the tmpfs options for the container
| Name | Type | Description |
|---|---|---|
| size |
integer (int32) |
Mention the Tmpfs size |
UserAccountCredentials
Settings for user account that gets created on each on the nodes of a compute.
| Name | Type | Description |
|---|---|---|
| adminUserName |
string |
User name. |
| adminUserPassword |
string |
Password. |
| adminUserSshPublicKey |
string |
SSH public key. |
UserAssignedIdentity
User assigned identity properties
| Name | Type | Description |
|---|---|---|
| clientId |
string (uuid) |
The client ID of the assigned identity. |
| principalId |
string (uuid) |
The principal ID of the assigned identity. |
VirtualMachine
A Machine Learning compute based on Azure Virtual Machines.
| Name | Type | Description |
|---|---|---|
| computeLocation |
string |
Location for the underlying compute |
| computeType | string: |
The type of compute |
| createdOn |
string (date-time) |
The time at which the compute was created. |
| description |
string |
The description of the Machine Learning compute. |
| disableLocalAuth |
boolean |
Opt-out of local authentication and ensure customers can use only MSI and AAD exclusively for authentication. |
| isAttachedCompute |
boolean |
Indicating whether the compute was provisioned by user and brought from outside if true, or machine learning service provisioned it if false. |
| modifiedOn |
string (date-time) |
The time at which the compute was last modified. |
| properties | ||
| provisioningErrors |
Errors during provisioning |
|
| provisioningState |
The provision state of the cluster. Valid values are Unknown, Updating, Provisioning, Succeeded, and Failed. |
|
| resourceId |
string |
ARM resource id of the underlying compute |
VirtualMachineImage
Virtual Machine image for Windows AML Compute
| Name | Type | Description |
|---|---|---|
| id |
string |
Virtual Machine image path |
VirtualMachineSshCredentials
Admin credentials for virtual machine
| Name | Type | Description |
|---|---|---|
| password |
string |
Password of admin account |
| privateKeyData |
string |
Private key data |
| publicKeyData |
string |
Public key data |
| username |
string |
Username of admin account |
VmPriority
Virtual Machine priority
| Value | Description |
|---|---|
| Dedicated | |
| LowPriority |
VolumeDefinition
Describes the volume configuration for the container
| Name | Type | Default value | Description |
|---|---|---|---|
| bind |
Bind Options of the mount |
||
| consistency |
string |
Consistency of the volume |
|
| readOnly |
boolean |
Indicate whether to mount volume as readOnly. Default value for this is false. |
|
| source |
string |
Source of the mount. For bind mounts this is the host path. |
|
| target |
string |
Target of the mount. For bind mounts this is the path in the container. |
|
| tmpfs |
tmpfs option of the mount |
||
| type | bind |
Type of Volume Definition |
|
| volume |
Volume Options of the mount |
VolumeDefinitionType
Type of Volume Definition
| Value | Description |
|---|---|
| bind | |
| volume | |
| tmpfs | |
| npipe |
VolumeOptions
Describes the volume options for the container
| Name | Type | Description |
|---|---|---|
| nocopy |
boolean |
Indicate whether volume is nocopy |